diff --git a/pithos-macos/PithosBrowserController.m b/pithos-macos/PithosBrowserController.m
index b976f87..0bcb45e 100644
--- a/pithos-macos/PithosBrowserController.m
+++ b/pithos-macos/PithosBrowserController.m
@@ -908,8 +1095,13 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
             if (!isDirectory) {
                 // Upload file
                 NSString *objectName = [objectNamePrefix stringByAppendingPathComponent:[filePath lastPathComponent]];
-                dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+                // Operation: Upload a local file
+                __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                    if (operation.isCancelled) {
+                        [pool drain];
+                        return;
+                    }
                     NSError *error = nil;
                     NSString *contentType = [PithosUtilities contentTypeOfFile:filePath error:&error];
                     if (contentType == nil)
@@ -917,6 +1109,10 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                     if (error)
                         NSLog(@"contentType detection error: %@", error);
                     NSArray *hashes = nil;
+                    if (operation.isCancelled) {
+                        [pool drain];
+                        return;
+                    }
                     ASIPithosObjectRequest *objectRequest = [PithosUtilities writeObjectDataRequestWithPithos:pithos 
                                                                                                 containerName:containerName 
                                                                                                    objectName:objectName 
@@ -927,7 +1123,7 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                                                 checkIfExists:YES 
                                                                                                        hashes:&hashes 
                                                                                                sharingAccount:destinationNode.sharingAccount];
-                    if (objectRequest) {
+                    if (!operation.isCancelled && objectRequest) {
                         objectRequest.delegate = self;
                         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -957,14 +1153,15 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                           NSStringFromSelector(@selector(uploadObjectUsingHashMapFinished:)), @"didFinishSelector", 
                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                           uploadNetworkQueue, @"networkQueue", 
-                          @"uploadQueue", @"queueType", 
+                          @"upload", @"operationType", 
                           nil]];
                         if (destinationNode.sharingAccount)
                             [(NSMutableDictionary *)objectRequest.userInfo setObject:destinationNode.sharingAccount forKey:@"sharingAccount"];
                         [uploadNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest]];
                     }
                     [pool drain];
-                });
+                }];
+                [uploadQueue addOperation:operation];
             } else {
                 // Upload directory, confirm first
                 NSAlert *alert = [[[NSAlert alloc] init] autorelease];
@@ -975,8 +1172,14 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                 NSInteger choice = [alert runModal];
                 if (choice == NSAlertFirstButtonReturn) {
                     NSString *objectName = [objectNamePrefix stringByAppendingPathComponent:[filePath lastPathComponent]];
-                    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+                    // Operation: Upload a local directory and its descendants
+                    // The resulting ASIPithosObjectRequests are chained through dependencies
+                    __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                         NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                        if (operation.isCancelled) {
+                            [pool drain];
+                            return;
+                        }
                         NSMutableArray *objectNames = nil;
                         NSMutableArray *contentTypes = nil;
                         NSMutableArray *filePaths = nil;
@@ -995,7 +1198,16 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                                         hashesArrays:&hashesArrays 
                                                                              directoryObjectRequests:&directoryObjectRequests 
                                                                                       sharingAccount:destinationNode.sharingAccount];
+                        if (operation.isCancelled) {
+                            [pool drain];
+                            return;
+                        }
+                        ASIPithosObjectRequest *previousObjectRequest = nil;
                         for (ASIPithosObjectRequest *objectRequest in directoryObjectRequests) {
+                            if (operation.isCancelled) {
+                                [pool drain];
+                                return;
+                            }
                             objectRequest.delegate = self;
                             objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                             objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -1014,12 +1226,19 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                               NSStringFromSelector(@selector(uploadDirectoryObjectFinished:)), @"didFinishSelector", 
                               NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                               uploadNetworkQueue, @"networkQueue", 
-                              @"uploadQueue", @"queueType", 
+                              @"upload", @"queue", 
                               nil]];
+                            if (previousObjectRequest)
+                                [objectRequest addDependency:previousObjectRequest];
+                            previousObjectRequest = objectRequest;
                             [uploadNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest]];
                         }
-                        if (objectRequests) {
+                        if (!operation.isCancelled && objectRequests) {
                             for (NSUInteger i = 0 ; i < [objectRequests count] ; i++) {
+                                if (operation.isCancelled) {
+                                    [pool drain];
+                                    return;
+                                }
                                 ASIPithosObjectRequest *objectRequest = [objectRequests objectAtIndex:i];
                                 objectRequest.delegate = self;
                                 objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
@@ -1049,15 +1268,19 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                   NSStringFromSelector(@selector(uploadObjectUsingHashMapFinished:)), @"didFinishSelector", 
                                   NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                                   uploadNetworkQueue, @"networkQueue", 
-                                  @"uploadQueue", @"queueType", 
+                                  @"upload", @"queue", 
                                   nil]];
                                 if (destinationNode.sharingAccount)
                                     [(NSMutableDictionary *)objectRequest.userInfo setObject:destinationNode.sharingAccount forKey:@"sharingAccount"];
+                                if (previousObjectRequest)
+                                    [objectRequest addDependency:previousObjectRequest];
+                                previousObjectRequest = objectRequest;
                                 [uploadNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest]];
                             }
                         }
                         [pool drain];
-                    });
+                    }];
+                    [uploadQueue addOperation:operation];
                 }
             }
         }
@@ -1079,8 +1302,13 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
     for (PithosNode *node in nodes) {
         if (([node class] == [PithosObjectNode class]) || 
             (([node class] == [PithosSubdirNode class]) && !node.pithosObject.subdir && [node.pithosObject.name hasSuffix:@"/"])) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Move an object or subdir/ node
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *destinationObjectName = [objectNamePrefix stringByAppendingPathComponent:node.displayName];
                 if ([node.pithosObject.name hasSuffix:@"/"])
                     destinationObjectName = [destinationObjectName stringByAppendingString:@"/"];
@@ -1090,7 +1318,7 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                             destinationContainerName:containerName 
                                                                                destinationObjectName:destinationObjectName 
                                                                                        checkIfExists:YES];
-                if (objectRequest) {
+                if (!operation.isCancelled && objectRequest) {
                     objectRequest.delegate = self;
                     objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                     objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -1113,15 +1341,22 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                       NSStringFromSelector(@selector(moveFinished:)), @"didFinishSelector", 
                       NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                       moveNetworkQueue, @"networkQueue", 
-                      @"moveQueue", @"queueType", 
+                      @"move", @"operationType", 
                       nil]];
                     [moveNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                 }
                 [pool drain];
-            });
+            }];
+            [moveQueue addOperation:operation];
         } else if ([node class] == [PithosSubdirNode class]) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Move a subdir node and its descendants
+            // The resulting ASIPithosObjectRequests are chained through dependencies
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *destinationObjectName = [objectNamePrefix stringByAppendingPathComponent:node.displayName];
                 if (node.pithosObject.subdir)
                     destinationObjectName = [destinationObjectName stringByAppendingString:@"/"];
@@ -1131,8 +1366,13 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                         destinationContainerName:containerName 
                                                                            destinationObjectName:destinationObjectName 
                                                                                    checkIfExists:YES];
-                if (objectRequests) {
+                if (!operation.isCancelled && objectRequests) {
+                    ASIPithosObjectRequest *previousObjectRequest = nil;
                     for (ASIPithosObjectRequest *objectRequest in objectRequests) {
+                        if (operation.isCancelled) {
+                            [pool drain];
+                            return;
+                        }
                         objectRequest.delegate = self;
                         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -1156,13 +1396,17 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                           NSStringFromSelector(@selector(moveFinished:)), @"didFinishSelector", 
                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                           moveNetworkQueue, @"networkQueue", 
-                          @"moveQueue", @"queueType", 
+                          @"move", @"operationType", 
                           nil]];
+                        if (previousObjectRequest)
+                            [objectRequest addDependency:previousObjectRequest];
+                        previousObjectRequest = objectRequest;
                         [moveNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                     }
                 }
                 [pool drain];
-            });
+            }];
+            [moveQueue addOperation:operation];
         }
     }
     return YES;
@@ -1182,8 +1426,13 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
     for (PithosNode *node in nodes) {
         if (([node class] == [PithosObjectNode class]) || 
             (([node class] == [PithosSubdirNode class]) && !node.pithosObject.subdir && [node.pithosObject.name hasSuffix:@"/"])) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Copy an object or subdir/ node
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *destinationObjectName;
                 if (![destinationNode isEqualTo:node.parent]) {
                     destinationObjectName = [objectNamePrefix stringByAppendingPathComponent:node.displayName];
@@ -1194,6 +1443,10 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                        containerName:containerName 
                                                                           objectName:node.pithosObject.name];
                 }
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 ASIPithosObjectRequest *objectRequest = [PithosUtilities copyObjectRequestWithPithos:pithos 
                                                                                        containerName:node.pithosContainer.name 
                                                                                           objectName:node.pithosObject.name 
@@ -1201,7 +1454,7 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                                destinationObjectName:destinationObjectName 
                                                                                        checkIfExists:YES 
                                                                                       sharingAccount:node.sharingAccount];
-                if (objectRequest) {
+                if (!operation.isCancelled && objectRequest) {
                     objectRequest.delegate = self;
                     objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                     objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -1224,15 +1477,22 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                       NSStringFromSelector(@selector(copyFinished:)), @"didFinishSelector", 
                       NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                       copyNetworkQueue, @"networkQueue", 
-                      @"copyQueue", @"queueType", 
+                      @"copy", @"operationType", 
                       nil]];
                     [copyNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                 }
                 [pool drain];
-            });
+            }];
+            [copyQueue addOperation:operation];
         } else if ([node class] == [PithosSubdirNode class]) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Copy a subdir node and its descendants
+            // The resulting ASIPithosObjectRequests are chained through dependencies
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *destinationObjectName;
                 if (![destinationNode isEqualTo:node.parent]) {
                     destinationObjectName = [objectNamePrefix stringByAppendingPathComponent:node.displayName];
@@ -1243,6 +1503,10 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                        containerName:containerName 
                                                                           subdirName:node.pithosObject.name];
                 }
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSArray *objectRequests = [PithosUtilities copyObjectRequestsForSubdirWithPithos:pithos 
                                                                                    containerName:node.pithosContainer.name 
                                                                                       objectName:node.pithosObject.name 
@@ -1250,8 +1514,13 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                                                            destinationObjectName:destinationObjectName 
                                                                                    checkIfExists:YES 
                                                                                   sharingAccount:node.sharingAccount];
-                if (objectRequests) {
+                if (!operation.isCancelled && objectRequests) {
+                    ASIPithosObjectRequest *previousObjectRequest = nil;
                     for (ASIPithosObjectRequest *objectRequest in objectRequests) {
+                        if (operation.isCancelled) {
+                            [pool drain];
+                            return;
+                        }
                         objectRequest.delegate = self;
                         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -1274,13 +1543,17 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                           NSStringFromSelector(@selector(copyFinished:)), @"didFinishSelector", 
                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                           copyNetworkQueue, @"networkQueue", 
-                          @"copyQueue", @"queueType", 
+                          @"copy", @"operationType", 
                           nil]];
+                        if (previousObjectRequest)
+                            [objectRequest addDependency:previousObjectRequest];
+                        previousObjectRequest = objectRequest;
                         [copyNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                     }
                 }
                 [pool drain];
-            });
+            }];
+            [copyQueue addOperation:operation];
         }
     }
     return YES;
@@ -1290,47 +1563,93 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 #pragma mark ASIHTTPRequestDelegate
 
 - (void)performRequestFinishedDelegateInBackground:(ASIPithosRequest *)request {
-    dispatch_queue_t queue;
-    if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"moveQueue"])
-        queue = moveQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"copyQueue"])
-        queue = copyQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"deleteQueue"])
-        queue = deleteQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"uploadQueue"])
-        queue = uploadQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"downloadQueue"])
-        queue = downloadQueue;
+    NSOperationQueue *callbackQueue;
+    NSString *operationType = [request.userInfo objectForKey:@"operationType"];
+    if ([operationType isEqualToString:@"move"])
+        callbackQueue = moveCallbackQueue;
+    else if ([operationType isEqualToString:@"copy"])
+        callbackQueue = copyCallbackQueue;
+    else if ([operationType isEqualToString:@"delete"])
+        callbackQueue = deleteCallbackQueue;
+    else if ([operationType isEqualToString:@"upload"])
+        callbackQueue = uploadCallbackQueue;
+    else if ([operationType isEqualToString:@"download"])
+        callbackQueue = downloadCallbackQueue;
     else
-        return;
-    dispatch_async(queue, ^{
-        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFinishSelector"]) withObject:request];
-    });
+        dispatch_async(dispatch_get_main_queue(), ^{
+            [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                              withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+        });
+    // Add an operation to the callbackQueue with a completionBlock for the case of cancellation
+    NSInvocationOperation *operation = [[[NSInvocationOperation alloc] initWithTarget:self 
+                                                                             selector:NSSelectorFromString([request.userInfo objectForKey:@"didFinishSelector"]) 
+                                                                               object:request] autorelease];
+    operation.completionBlock = ^{
+        NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+        if ([[request.userInfo objectForKey:@"operation"] isCancelled]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                                  withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+            });
+        }
+        [pool drain];
+    };
+    [(NSMutableDictionary *)request.userInfo setObject:operation forKey:@"operation"];
+    [callbackQueue addOperation:operation];
 }
 
 - (void)performRequestFailedDelegateInBackground:(ASIPithosRequest *)request {
-    dispatch_queue_t queue;
-    if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"moveQueue"])
-        queue = moveQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"copyQueue"])
-        queue = copyQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"deleteQueue"])
-        queue = deleteQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"uploadQueue"])
-        queue = uploadQueue;
-    else if ([[request.userInfo objectForKey:@"queueType"] isEqualToString:@"downloadQueue"])
-        queue = downloadQueue;
-    else
-        return;
-    dispatch_async(queue, ^{
-        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) withObject:request];
-    });
+    if (request.isCancelled) {
+        // Request has been cancelled 
+        // The callbackQueue might be suspended so we call directly the callback method, since it does minimal work anyway
+        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) 
+                   withObject:request];
+    } else {
+        NSOperationQueue *callbackQueue;
+        NSString *operationType = [request.userInfo objectForKey:@"operationType"];
+        if ([operationType isEqualToString:@"move"])
+            callbackQueue = moveCallbackQueue;
+        else if ([operationType isEqualToString:@"copy"])
+            callbackQueue = copyCallbackQueue;
+        else if ([operationType isEqualToString:@"delete"])
+            callbackQueue = deleteCallbackQueue;
+        else if ([operationType isEqualToString:@"upload"])
+            callbackQueue = uploadCallbackQueue;
+        else if ([operationType isEqualToString:@"download"])
+            callbackQueue = downloadCallbackQueue;
+        else
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                                  withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+            });
+        // Add an operation to the callbackQueue with a completionBlock for the case of cancellation
+        NSInvocationOperation *operation = [[[NSInvocationOperation alloc] initWithTarget:self 
+                                                                                 selector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) 
+                                                                                   object:request] autorelease];
+        operation.completionBlock = ^{
+            NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+            if ([[request.userInfo objectForKey:@"operation"] isCancelled]) {
+                dispatch_async(dispatch_get_main_queue(), ^{
+                    [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                                      withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+                });
+            }
+            [pool drain];
+        };
+        [(NSMutableDictionary *)request.userInfo setObject:operation forKey:@"operation"];
+        [callbackQueue addOperation:operation];
+    }
 }
 
 - (void)requestFailed:(ASIPithosRequest *)request {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [request.userInfo objectForKey:@"operation"];
     NSLog(@"Request failed: %@", request.url);
-    if ([request isCancelled]) {
+    if (operation.isCancelled) {
+        [pool drain];
+        return;        
+    }
+    if (request.isCancelled) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
                               withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
@@ -1359,8 +1678,11 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)downloadObjectFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Download finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 200) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 200) {
         NSString *filePath = [objectRequest.userInfo objectForKey:@"filePath"];
         PithosActivity *activity = [objectRequest.userInfo objectForKey:@"activity"];
         NSUInteger totalBytes = activity.totalBytes;
@@ -1400,8 +1722,11 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)uploadDirectoryObjectFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Upload directory object finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         NSLog(@"Directory object created: %@", objectRequest.url);
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
